# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_transformer
		@setting=[]
		@status_menu=[]
		class Transformer
			def initialize(sels,transformer=0,point=[])
				@select=sels
				@transformer=transformer
				@points=point
				@elements=[]
				@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@scale_factor = 1.8 if @scale_factor>1.8
				@snap=20*@scale_factor
			end
			def activate
				@active_tool=[Strings["Transformer Scale"],Strings["Transformer Move"],Strings["Transformer Rotate"],Strings["Transformer Color"]]
				@base=["Min","Max-X","Max-Y","Max-XY","Max-Z","Max-XZ","Max-YZ","Max","Bottom","Center","Top","Front","Right","Left","Back","Origin"]
				@axis=["Red","Green","Blue","Red-Green","Red-Blue","Green-Blue","Red-Green-Blue"]
				@base_list=[[0,0,0],[-1,0,0],[0,-1,0],[-1,-1,0],[0,0,-1],[-1,0,-1],[0,-1,-1],[-1,-1,-1],[0.5,0.5,0],[0.5,0.5,0.5],[0.5,0.5,-1],[0.5,0,0.5],[-1,0.5,0.5],[0,0.5,0.5],[0.5,-1,0.5],[0,0,0]]
				@axis_list=[[1,0,0],[0,1,0],[0,0,1],[1,1,0],[1,0,1],[0,1,1],[1,1,1]]
				@scale_list=[Strings["Distance"],Strings["Ratio"],Strings["Fixed length"]]
				@dynamic_list=[Strings["No"],Strings["Circle"],Strings["Linear"],Strings["Points"],Strings["Random"],Strings["Set"]]
				@main_list=[Strings["Scale"],Strings["Move"],Strings["Rotate"],Strings["Color"]]
				@reset_list=[Strings["Scale"],Strings["Rotate"],Strings["Color"],Strings["Transform"]]
				@extend_list=[Strings["Ex-Scale"],Strings["Lowest"],Strings["Highest"],Strings["Height?"]]
				self.setvar
				if (@transformer==10) && (@points==true)
					self.process_move(nil,@index_extend=3)
					Sketchup.active_model.select_tool(nil)
				end
			end
			def deactivate(view)
                if @menus
                    @status_menu=@menus.menu.collect{|m| m.enable}
                    model=view.model
                    vars= [@scale_mode,@index_axis, @index_base, @paint,@opacity, @dynamic_mode,@dynamic_type,@min_max,@input,@height,@index_axis_height]
                    (0..vars.length-1).each{|i| @setting[i]=vars[i] }
                    S4U::S4u_transformer::instance_variable_set(:@setting,@setting)
                    S4U::S4u_transformer::instance_variable_set(:@status_menu,@status_menu)
                    view.model.selection.add @elements.collect{|e| e[0]}
                end
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip.valid?
				bb.add @ip1.position if @ip1.valid?
				bb.add @ip2.position if @ip2.valid?
				return bb
			end
			def setvar(view=nil)
				@elements.clear
				@materials=[]
				@select.each{ |i|
					if i.valid?
						b=S4U::S4u_transformer.get_bounds(i)
						@elements<<[i,b] if b
					end
				}
				@setting =  S4U::S4u_transformer::instance_variable_get :@setting
				@status_menu = S4U::S4u_transformer::instance_variable_get :@status_menu
				if @setting && @setting.length>0
					i=-1
					@scale_mode=@setting[i+=1]
					@transformer=@scale_mode if @transformer<10
					@index_axis=@setting[i+=1]
					@index_base=@setting[i+=1]
					@paint=@setting[i+=1]
					@opacity=@setting[i+=1]
					@dynamic_mode=@setting[i+=1]
					@dynamic_type=@setting[i+=1]
					@min_max=@setting[i+=1]
					@input=@setting[i+=1]
					@height=@setting[i+=1]
					@index_axis_height=@setting[i+=1]
					(@paint[0]=1) if @transformer==30
				else
					@scale_mode=0
					@index_axis=2
					@index_base=0
					@paint=@transformer==30 ? [1,[0,359],[70,70],[70,70]] : [0,[0,359],[70,70],[70,70]]
					@opacity=[0,[0,100]]
					@dynamic_mode=0
					@dynamic_type=0
					@min_max=[[[0.to_l,'100'.to_l],[0.to_f,'10'.to_f],[0.to_l,'100'.to_l]],[[0.to_l,'100'.to_l]],[[0.to_f,'90'.to_f]],[[0.to_f,'100'.to_f]]]
					@input=[[0.to_l,0.to_l,0.0],[0.to_l],[0.0],[0.0]]
					@height=0
					@index_axis_height=2
				end
				@ip=Sketchup::InputPoint.new
				@ip1=Sketchup::InputPoint.new
				@ip2=Sketchup::InputPoint.new
				@point1=nil
				@point2=nil
				@vec_shift=nil
				self.reset
				@menus=S4U::S4u_menu.new
				@menus.add @menu_main = S4U::S4u_items.new("Main", @main_list , true, @menus.last.clone ,270)
				@menus.add @menu_reset = S4U::S4u_items.new("Reset", @reset_list , true, @menus.last.clone ,320)
				@menus.add @menu_extend = S4U::S4u_items.new("Extend", @extend_list , true, @menus.last.clone ,300)
				@index_extend=0
				@menus.add @menu_dynamic = S4U::S4u_items.new("Dynamic", @dynamic_list , true, @menus.last.clone ,400,60)
				@index_dynamic=@dynamic_mode
				@menus.add @menu_scale = S4U::S4u_items.new("Scale mode",@scale_list , true, @menus.last.clone ,310,80)
				@index_reset=0
				@menus.last=[0,@menu_dynamic.height,0]
				@menus.add @menu_base = S4U::S4u_items.new("Base" , @base ,true, @menus.last.clone , 850)
				@menus.add @menu_axis = S4U::S4u_items.new("Axis", @axis , true, @menus.last.clone , 650)
				(0..6).each{|i|
					@menu_axis.items[i].width =70*@scale_factor
					@menu_axis.items[i].position.x= @menu_axis.position.x+ 70.0*i*@scale_factor +  @menu_axis.head
				}
				@menu_axis.items[6].width=100*@scale_factor
				if !@status_menu.empty?
					@menus.menu.each_index{|i| @menus.menu[i].enable=@status_menu[i]}
					@menus.reset
				end
				self.setstatus view
			end
			def set_bounds(elements)
				elements.each{ |e|
					if e[0].valid?
						b=S4U::S4u_transformer.get_bounds(e[0])
						e[1]=b if b
					end
				}
			end
			def reset
				tedit=Sketchup.version.to_i>=16 ? Sketchup.active_model.axes.transformation : Sketchup.active_model.edit_transform
				@vec = tedit.zaxis
				@ip.clear;@ip1.clear;@ip2.clear
				@state=0
			end
			def set_select_menu(menu)
				case menu[0]
				when @menu_axis
					@index_axis=@axis.index(menu[1][0].text)
				when @menu_base
					@index_base=@base.index(menu[1][0].text)
				when  @menu_dynamic
					@index_dynamic=@dynamic_list.index(menu[1][0].text)
					if @index_dynamic<5
						@dynamic_mode=@index_dynamic
						self.reset
						self.transformer_dynamic(@dynamic_mode) if @dynamic_mode==3 || @dynamic_mode==4
					else
						self.get_dynamic_parameter if @index_dynamic==5
					end
				when  @menu_scale
					@transformer=@scale_mode=@scale_list.index(menu[1][0].text)
				when  @menu_reset
					@index_reset=@reset_list.index(menu[1][0].text)
					case @index_reset
					when 0
						self.reset_scales
					when 1
						self.reset_transforms(false)
					when 2
						self.process_color(nil)
					when 3
						self.reset_transforms
					end
				when @menu_main
					index=@main_list.index(menu[1][0].text)
					@transformer= (index==0) ? @scale_mode : (index*10)
				when @menu_extend
					@index_extend=@extend_list.index(menu[1][0].text)
					if @index_extend==0
						self.process_scale(nil)
					elsif @index_extend.between?(1,3)
						self.process_move(nil,@index_extend)
					end
				end
			end
			def mid(p1,p2)
				return Geom.linear_combination(0.5, p1,0.5,p2)
			end
			def onLButtonDown(flags, x, y, view)
				menu=@menus.process_onLButtonDown( x, y)
				if @menus && menu
					self.set_select_menu(menu)
					self.setstatus(view)
					self.reset
				elsif @dynamic_mode==0 || @ctrl_press
					if @ip.valid?
						if @ctrl_press && @transformer==10
							value=@ip.position.transform(Sketchup.active_model.axes.transformation.inverse)[@index_axis]
							self.process_move(value)
						else
							ph = view.pick_helper
							ph.init(x, y)
							ph.do_pick(x, y)
							best_picked=ph.best_picked
							sels=@elements.collect{|e| e[0]}
							if !(best_picked && sels.include?(best_picked))
								best_entity = sels.sort_by{|e| view.screen_coords(e.bounds.center).distance view.screen_coords(@ip.position) }
								best_picked = best_entity[0] if best_entity && best_entity[0]
							end
							if best_picked
								#base=["Min","Max-X","Max-Y","Max-XY","Max-Z","Max-XZ","Max-YZ","Max","Bottom","Center","Top","Front","Right","Left","Back","Origin"]
								b=get_bounds(best_picked)
								base=[b[0],b[1],b[2],b[3],b[4],b[5],b[6],b[7],mid(b[0],b[3]),mid(b[0],b[7]),mid(b[4],b[7]),mid(b[0],b[5]),mid(b[1],b[7]),mid(b[0],b[6]),mid(b[2],b[7])]
								picked_bound = base.find{|p| ph.test_point(p,x,y,1.5*@snap) }
								if picked_bound
									index_base=base.index(picked_bound)
									@index_base=index_base if index_base
								end
							end
						end
					end
				elsif (@dynamic_mode!=0) && (@dynamic_mode<=2)
					if @state==0
						if @ip.valid?
							@ip1.copy! @ip
							@state=1
						end
					elsif @state==1
						if @ip.valid? and (@ip1.position !=@ip.position)
							@ip2.copy! @ip
							@point1=@ip1.position
							@point2=@ip2.position
							self.reset
							self.transformer_dynamic(@dynamic_mode,@point1,@point2)
						end
					end
					self.setstatus(view)
				end
			end
			def get_bounds(element)
				a=element.transformation.to_a
				b=nil
				if element.is_a?Sketchup::ComponentInstance
					b=element.definition.bounds
				elsif element.is_a?Sketchup::Group
					b=element.local_bounds
				else
					return nil
				end
				return (0..7).collect{|i| b.corner(i).clone.transform! element.transformation } if b
			end
			def set_special_point(x,y,view,ip)
				points=[]
				ph = view.pick_helper
				ph.init(x, y)
				ph.do_pick(x, y)
				sels=@elements.collect{|e| e[0]}
				best_entity = sels.sort_by{|e| view.screen_coords(e.bounds.center).distance view.screen_coords(ip.position) }
				best_entity=best_entity[0..7]
				if !best_entity.empty?
					best_entity.each{|e|
						b = get_bounds(e)
						base=[b[0],b[1],b[2],b[3],b[4],b[5],b[6],b[7],mid(b[0],b[3]),mid(b[0],b[7]),mid(b[4],b[7]),mid(b[0],b[5]),mid(b[1],b[7]),mid(b[0],b[6]),mid(b[2],b[7])]
						points += base
					}
				end
				points.uniq!
				picked_bounds = points.find{|p| ph.test_point(p,x,y,@snap) }
				if picked_bounds
					ip1=Sketchup::InputPoint.new(picked_bounds)
					ip.copy! ip1
					view.tooltip=Strings["BoundingBox"]
					@point=picked_bounds
					return ip
				else
					@point=nil
				end
			end
			def onMouseMove(flags, x, y, view)
				#@shift_press= (CONSTRAIN_MODIFIER_MASK&flags==CONSTRAIN_MODIFIER_MASK)
				@ctrl_press= (COPY_MODIFIER_MASK&flags==COPY_MODIFIER_MASK)
				#@alt_press= (ALT_MODIFIER_MASK&flags==ALT_MODIFIER_MASK)
				if @dynamic_mode!=0 && @dynamic_mode<=2
					if  @state==0
						@ip.pick view, x, y
						if @vec_shift
							@vec=@vec_shift
						else
							tedit=Sketchup.version.to_i>=16 ? Sketchup.active_model.axes.transformation : Sketchup.active_model.edit_transform
							@vec = (@ip.valid? && @ip.face) ? @ip.face.normal : tedit.zaxis
						end
						view.invalidate if @ip.valid? && @ip.display?
					elsif @state==1
						@ip.pick view, x, y, @ip1
						if @ip.valid? && @ip.display?
							view.invalidate
							length = @ip1.position.distance(@ip.position)
							Sketchup::set_status_text length.to_s, SB_VCB_VALUE
						end
					end
				elsif @dynamic_mode==0 || @ctrl_press
					@ip.pick view, x, y
					set_special_point(x,y,view,@ip) if !@ctrl_press
				end
				@menus.process_onMouseMove(x, y) if @menus
				self.setstatus(view)
			end
			def draw(view)
				if @dynamic_mode==0 || @ctrl_press
					model=view.model
					view.line_width=2
					view.drawing_color="red"
					if @point
						view.draw_points @ip.position, 10*@scale_factor, 1, "red"
					elsif @ctrl_press && @transformer==10
						@ip.draw(view)
					end
				end
				if (@elements.detect{|e| e[0].deleted?})
					Sketchup.active_model.select_tool(nil)
				else
					if (@dynamic_mode!=0) && (@dynamic_mode<=2) && @ip.valid?
						@ip.draw(view)
						self.draw_shape(view) if (@state==1) && @ip.valid? && @ip1.valid? && (@ip.position != @ip1.position)
					end
					self.draw_elements(@elements,view)
					@menus.draw(view)
					self.setstatus
				end
			end
			def draw_shape(view)
				model=view.model
				#model.start_operation @active_tool[@transformer.div(10)],true,false,true
				view.line_width=2
				view.drawing_color="blue"
				if @dynamic_mode==1
					vz=@vec
					return if vz.valid? && vz.length==0
					poly=draw_circle(@ip1.position,vz,(@ip1.position.distance @ip.position))
					if vz.y==0 && vz.z==0
						view.drawing_color="red"
					elsif vz.x==0 && vz.z==0
						view.drawing_color="green"
					elsif vz.x==0 && vz.y==0
						view.drawing_color="blue"
					end
					view.draw_polyline poly
				elsif @dynamic_mode ==2
					view.set_color_from_line @ip1.position,@ip.position
					view.draw_line @ip1.position,@ip.position
					vec=@ip1.position.vector_to @ip.position
					vec.length=view.pixels_to_model 10,ORIGIN
					p=@ip.position + vec.reverse
					@vz=vec.cross @vec
					tedit=Sketchup.version.to_i>=16 ? Sketchup.active_model.axes.transformation : Sketchup.active_model.edit_transform
					@vz=vec.cross tedit.yaxis if @vz.length==0
					@vz=vec.cross tedit.xaxis if @vz.length==0
					if @vz.valid? && @vz.length!=0
						@vz.length=view.pixels_to_model 10,ORIGIN
						p1=p+ @vz
						p2=p+ @vz.reverse
						p3=@ip1.position.clone+@vz
						p4=@ip1.position.clone+@vz.reverse
						view.draw_line @ip.position,p1
						view.draw_line @ip.position,p2
						view.draw_line @ip1.position,p3
						view.draw_line @ip1.position,p4
					end
				end
				view.line_width=0
				rescue =>error
				p error
				#model.commit_operation
			end
			def draw_circle(point=ORIGIN,vector=Z_AXIS,radius=1,numsegs=48)
				c=[]
				a=2*Math::PI / numsegs
				(0..numsegs).each{|t| c<< ([radius*Math::cos(t*a),radius*Math::sin(t*a),0].transform! Geom::Transformation.new( point,vector)) }
				return c
			end
			def draw_elements(elements,view)
				self.set_bounds(elements)

				size = @size_pixels ? @size_pixels : (view.pixels_to_model 9,ORIGIN)
				size1=size>6? ((9/ size)>0.2 ? ((9/ size)>2 ? 2 : (9/ size)) :  0.2 ) : 2
				elements.each{|e|
					t=e[0].transformation
					b=e[1][0]
					p=e[1][1]
					vx=t.xaxis;vy=t.yaxis;vz=t.zaxis
					vec=[vx,vy,vz]
					origin_new=[(b.x*@base_list[@index_base].x),(b.y*@base_list[@index_base].y),(b.z*@base_list[@index_base].z)]
					(0..2).each{|i|
						if origin_new[i]!=0
							vec[i].length=origin_new[i].abs
							p=p+vec[i]
						end
						vec[i].reverse! if origin_new[i]<0
						x= (@base_list[@index_base][i]==0) ? 1 : (@base_list[@index_base][i].abs)
						vec[i].length= x*b[i]+size*@axis_list[@index_axis][i] if vec[i].length!=0
					}
					p=t.origin	if @index_base==15
					(0..2).each{|i|
						view.drawing_color = ["red","green","blue"][i]
						view.line_width = 1.5*size1*(1+ 2*@axis_list[@index_axis][i])
						(view.draw_line p,p+ vec[i]) if vec[i].length!=0
					}
				}
			end
			def getMenu(menu)
				list_transformer=[]	;list_base=[];list_axis=[]
				(0..@active_tool.length-1).each{|i|	list_transformer<< menu.add_item(@active_tool[i]){  @transformer=((i==0) ? @scale_mode : (i*10)) } }
				menu.add_separator
				menu_base=menu.add_submenu(Strings["Select base  >"])
				(0..@base.length-1).each{|i| list_base<< menu_base.add_item(@base[i]) {  @index_base=i  } }
				menu_axis=menu.add_submenu(Strings["Select Axis  >"])
				(0..@axis.length-1).each{|i| list_axis<< menu_axis.add_item(@axis[i]) {  @index_axis=i } }
				menu.add_separator
				if @transformer<10
					menu.add_separator
					scale_mode=[]
					scale_mode<< menu.add_item(Strings["Scale distance"]) { @transformer=@scale_mode=0 }
					scale_mode<< menu.add_item(Strings["Scale ratio"]) { @transformer=@scale_mode=1  }
					scale_mode<< menu.add_item(Strings["Scale fixed length"]) { @transformer=@scale_mode=2 }
					scale_mode.each{|l| menu.set_validation_proc(l) { MF_UNCHECKED }}
					menu.set_validation_proc(scale_mode[@scale_mode] ) { MF_CHECKED } if @transformer<3
				elsif @transformer==10
					move_mode=[];dynamic=[]
					move_mode<< menu.add_item(Strings["Move to lowest"]) { self.process_move(nil,@index_extend=1) }
					move_mode<< menu.add_item(Strings["Move to highest"]) { self.process_move(nil,@index_extend=2)}
					move_mode<< menu.add_item(Strings["Move to height?"]) { self.process_move(nil,@index_extend=3) }
					move_mode.each{|l| menu.set_validation_proc(l) { MF_UNCHECKED }}
				end
					dynamic=[]
					menu.add_separator
					dynamic<< menu.add_item(Strings["No dynamic"]) { @dynamic_mode=@index_dynamic=0 }
					dynamic<< menu.add_item(Strings["Dynamic circle"]) { @dynamic_mode=@index_dynamic=1  }
					dynamic<< menu.add_item(Strings["Dynamic linear"]) { @dynamic_mode=@index_dynamic=2  }
					dynamic<< menu.add_item(Strings["Dynamic to points"]) { self.transformer_dynamic(@dynamic_mode=@index_dynamic=3)  }
					dynamic<< menu.add_item(Strings["Dynamic random"]) { self.transformer_dynamic(@dynamic_mode=@index_dynamic=4)}
					dynamic<<menu.add_item(Strings["Set dynamic parameter"]) { @index_dynamic=5 ;self.get_dynamic_parameter}
					dynamic.each{|l| menu.set_validation_proc(l) { MF_UNCHECKED }}
					menu.set_validation_proc(dynamic[@dynamic_mode]) { MF_CHECKED }
				menu.add_separator
				if @transformer<10
					extend_scale=menu.add_item(Strings["Extend scale"]) { self.process_scale(nil);@index_extend=0}
					menu.set_validation_proc(extend_scale) { MF_UNCHECKED }
				end
				reset_scale=menu.add_item(Strings["Reset scale"]) {self.reset_scales ;@index_reset=0}
				menu.set_validation_proc(reset_scale) { MF_UNCHECKED }
				reset_rotate=menu.add_item(Strings["Reset rotate"]) { self.reset_transforms(false) ;@index_reset=1}
				menu.set_validation_proc(reset_rotate) { MF_UNCHECKED }
				reset_color=menu.add_item(Strings["Reset color"]) { self.process_color(nil);@index_reset=2 }
				menu.set_validation_proc(reset_color) { MF_UNCHECKED }
				reset_transform=menu.add_item(Strings["Reset Transformer"]) { self.reset_transforms;@index_reset=3 }
				menu.set_validation_proc(reset_transform) { MF_UNCHECKED }
				list_transformer.each{|l| menu.set_validation_proc(l) { MF_UNCHECKED }}
				menu.set_validation_proc(list_transformer[@transformer.div(10)]) { MF_CHECKED }
				list_base.each{|l| menu.set_validation_proc(l) { MF_UNCHECKED }}
				menu.set_validation_proc(list_base[@index_base]) { MF_CHECKED }
				list_axis.each{|l| menu.set_validation_proc(l) { MF_UNCHECKED }}
				menu.set_validation_proc(list_axis[@index_axis]) { MF_CHECKED }
				self.setstatus(Sketchup.active_model.active_view)
			end
			def process_scale(input)
				model =Sketchup.active_model
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				if input
					value= (@transformer!=1) ? (self.parse_length input) : input.to_f
					self.scale_tool(@elements,value)
				else
					scales=[]
					@elements.each{|e|
					(0..2).each{|i|
					if @axis_list[@index_axis][i]==1
						trans=S4U::S4u_transformer.create_transform(e,@index_base)
						b=e[1][0]
						t=trans[0]
						p=trans[1].clone
						vec=[t.xaxis,t.yaxis,t.zaxis][i]
						x= (@base_list[@index_base][i]==0) ? 1 : (@base_list[@index_base][i].abs)
						vec.length= x*b[i] if vec.length!=0
						p1=p + vec
						if vec.length!=0
							ray=[p1,vec]
							point=model.raytest ray
							if point && (point[0] != p)
								d=(p1.distance point[0])/ x
								scales<< [e,d,i] if d!=0
							end
						end
					  end
					}
					}
					scales.each{|s| self.scale_tool([s[0]],s[1],0,s[2])}
				end
				self.set_bounds(@elements)
				model.commit_operation
			end
			def scale_tool(objects,value,scale_mode=@transformer,index_axis=@index_axis)
				objects.each{|e|
					if  scale_mode==1 #ratio
						sx= (@axis_list[index_axis][0]==0) ? 1 : value
						sy= (@axis_list[index_axis][1]==0) ? 1 : value
						sz= (@axis_list[index_axis][2]==0) ? 1 : value
						self.scale(e,sx,sy,sz)
					else
						b=e[1][0]
						dx=b.x*@axis_list[index_axis][0]
						dy=b.y*@axis_list[index_axis][1]
						dz=b.z*@axis_list[index_axis][2]
						if scale_mode ==2 #fix length
							sx= ((dx==0) ? 1 : (value/ dx))
							sy= ((dy==0) ? 1 : (value/ dy))
							sz= ((dz==0) ? 1 : (value/ dz))
							if ((b.z==0)) || ((b.y==0)) || ((b.x==0))
								trans=S4U::S4u_transformer.create_transform(e,@index_base)
								t=e[0].transformation
								vx=(t.xaxis.length==0) ? (t.yaxis.cross t.zaxis) : t.xaxis
								vy=(t.yaxis.length==0) ? (t.zaxis.cross t.xaxis) : t.yaxis
								vz=(t.zaxis.length==0) ? (t.xaxis.cross t.yaxis) : t.zaxis
								if vx.length!=0 && vy.length!=0 && vz.length!=0
									e[0].transformation=Geom::Transformation.new(vx,vy,vz,trans[1])
									e[1]=S4U::S4u_transformer.get_bounds(e[0])
									b1=e[1][0]
									dx=b1.x*@axis_list[index_axis][0]
									dy=b1.y*@axis_list[index_axis][1]
									dz=b1.z*@axis_list[index_axis][2]
									sx= ((dx==0) ? (b.x/ b1.x) : (value/ dx))
									sy= ((dy==0) ? (b.y/ b1.y) : (value/ dy))
									sz= ((dz==0) ? (b.z/ b1.z) : (value/ dz))
									sx=(b1.x==0) ? 1 : sx
									sy=(b1.y==0) ? 1 : sy
									sz=(b1.z==0) ? 1 : sz
									self.scale(e,sx,sy,sz)
									new_trans=S4U::S4u_transformer.create_transform(e,@index_base)
									if trans[1]!=new_trans[1]
										vec=trans[1]-new_trans[1]
										e[0].transform!(Geom::Transformation.translation(vec))
									end
								end
							else
								self.scale(e,sx,sy,sz)
							end
						else #distance
							sx=1+ ((dx==0) ? 0 : (value/ dx))
							sy=1+ ((dy==0) ? 0 : (value/ dy))
							sz=1+ ((dz==0) ? 0 : (value/ dz))
							if ((b.z==0)) || ((b.y==0)) || ((b.x==0))
								trans=S4U::S4u_transformer.create_transform(e,@index_base)
								t=e[0].transformation
								vx=(t.xaxis.length==0) ? (t.yaxis.cross t.zaxis) : t.xaxis
								vy=(t.yaxis.length==0) ? (t.zaxis.cross t.xaxis) : t.yaxis
								vz=(t.zaxis.length==0) ? (t.xaxis.cross t.yaxis) : t.zaxis
								if vx.length!=0 && vy.length!=0 && vz.length!=0
									e[0].transformation=Geom::Transformation.new(vx,vy,vz,trans[1])
									e[1]=S4U::S4u_transformer.get_bounds(e[0])
									b1=e[1][0]
									if (b1[0]!=0 && b[0]==0) || (b1[1]!=0 && b[1]==0) || (b1[2]!=0 && b[2]==0)
										dx1=b1.x*@axis_list[index_axis][0]
										dy1=b1.y*@axis_list[index_axis][1]
										dz1=b1.z*@axis_list[index_axis][2]
										sx= ((dx==0)? ((b1.x==0) ? 1 : (b.x/ b1.x)) : 1) + ((dx1==0) ? 0 : (value/ dx1))
										sy= ((dy==0)? ((b1.y==0) ? 1 : (b.y/ b1.y)) : 1) + ((dy1==0) ? 0 : (value/ dy1))
										sz= ((dz==0)? ((b1.z==0) ? 1 : (b.z/ b1.z)) : 1) + ((dz1==0) ? 0 : (value/ dz1))
										self.scale(e,sx,sy,sz)
										new_trans=S4U::S4u_transformer.create_transform(e,@index_base)
										if trans[1]!=new_trans[1]
											vec=trans[1]-new_trans[1]
											e[0].transform!(Geom::Transformation.translation(vec))
										end
									 else
										e[0].transformation=t
										e[1]=S4U::S4u_transformer.get_bounds(e[0])
										self.scale(e,sx,sy,sz)
									 end
								end
							else
								self.scale(e,sx,sy,sz)
							end
						end
					end
				}
			end
			def scale(element,x,y,z,index_base=@index_base)
				e=element[0]
				b=element[1]
				trans=S4U::S4u_transformer.create_transform(element,index_base)
				e.transformation = e.transformation*Geom::Transformation.new([x,0,0,0,0,y,0,0,0,0,z,0,0,0,0,1])
				self.set_origin(e,trans[1])
				bounds=S4U::S4u_transformer.get_bounds(e)
				trans_new=S4U::S4u_transformer.create_transform([e,bounds],index_base)
				if trans[1]!=trans_new[1]
					vec = trans[1]-trans_new[1]
					e.transform!(Geom::Transformation.translation(vec))
				end
			end
			def set_origin(element,p)
				a=element.transformation.to_a
				(0..2).each{|i| a[12+i]=p[i]}
				element.transformation =Geom::Transformation.new a
			end
			def process_move(value,mode=0,index_base=@index_base,index_axis=@index_axis)
				value=self.parse_length value if value
				return if value && value==0 && !@ctrl_press
				model =Sketchup.active_model
				ents=model.active_entities
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				if value
					self.move_tool(@elements,value)
				else
					moves=[]
					if mode==1 || mode==2
						@elements.each{|e|
							(0..2).each{|i|
								if @axis_list[@index_axis][i]==1
									trans=S4U::S4u_transformer.create_transform(e,@index_base)
									b=e[1][0]
									t=trans[0]
									p=trans[1].clone
									vec=[t.xaxis,t.yaxis,t.zaxis][i]
									x= (@base_list[@index_base][i]==0) ? 1 : (@base_list[@index_base][i].abs)
									vec.length= x*b[i] if vec.length!=0
									p1=mode==1 ? (p.clone + vec.reverse!) : (p.clone + vec)
									p2=Geom::Point3d.new p1
									if p2 && vec.length!=0
										ray=[p1,vec]
										point=model.raytest ray
										if point && (point[0] != p)
											vec=p.vector_to point[0]
											moves<< [e[0],vec]
										end
									end
								end
							}
						}
						moves.each{|m| m[0].transform!(Geom::Transformation.translation(m[1])) }
					else
						@height=self.get_height(0)
						if @height
							tedit= Sketchup.version.to_i>=16 ? model.axes.transformation : model.edit_transform
							a=tedit.to_a
							s=[Math.sqrt(a[0]**2+a[1]**2+a[2]**2),Math.sqrt(a[4]**2+a[5]**2+a[6]**2),Math.sqrt(a[8]**2+a[9]**2+a[10]**2)]
							@elements.each{|e|
								trans=S4U::S4u_transformer.create_transform(e,@index_base)
								p=trans[1].transform tedit.inverse
								axis=[tedit.xaxis,tedit.yaxis,tedit.zaxis]
								axis.each_index{|i|
									if (@axis_list[@index_axis_height][i]==1) && (p[i]!= @height)
										vec=axis[i]
										vec.length=@height-p[i]*s[i]
										e[0].transform!(Geom::Transformation.translation(vec))
									end
								}
							}
						end
					end
				end
				self.set_bounds(@elements)
				model.commit_operation
			end
			def get_height(height)
				value=nil
				prompts = [Strings["Axis of Model"],Strings["Base"],Strings["Height?"]]
				str=Strings["Enter Height"]
				axis=["X","Y","Z","X-Y","X-Z","Y-Z","X-Y-Z"]
				@index_axis_height=2 if !@index_axis_height
				defaults = [axis[@index_axis_height],@base[@index_base],self.parse_length(@height).to_s]
				base=@base.collect{|b| b}
				list=[axis.join('|'),base.join('|'),""]
				input = UI.inputbox(prompts,defaults,list,str)
				if input
					a=axis.index(input[0])
					@index_axis_height=a if (0<=a) && (a<axis.length)
					b=@base.index(input[1])
					@index_base=b if (0<=b) && (b<@base.length)
					value=self.parse_length(input[2])
					@menu_base.set_select(@index_base) if @menu_base
				end
				return value
			end
			def move_tool(elements,value,index_base=@index_base,index_axis=@index_axis)
				if @ctrl_press && @transformer==10
					tedit= Sketchup.version.to_i>=16 ? Sketchup.active_model.axes.transformation : Sketchup.active_model.edit_transform
					a=tedit.to_a
					s=[Math.sqrt(a[0]**2+a[1]**2+a[2]**2),Math.sqrt(a[4]**2+a[5]**2+a[6]**2),Math.sqrt(a[8]**2+a[9]**2+a[10]**2)]

					elements.each{|e|
						trans=S4U::S4u_transformer.create_transform(e,@index_base)
						p=trans[1].transform tedit.inverse
						axis=[tedit.xaxis,tedit.yaxis,tedit.zaxis]
						axis.each_index{|i|
							if (@axis_list[@index_axis][i]==1) && (p[i]!= value)
								vec=axis[i]
								vec.length=value-p[i]*s[i]
								e[0].transform!(Geom::Transformation.translation(vec))
							end
						}
					}
				else
					elements.each{|e|
						trans=S4U::S4u_transformer.create_transform(e,index_base)
						t=trans[0]
						(0..2).each{|i|
							if @axis_list[index_axis][i]==1
								vec=[t.xaxis,t.yaxis,t.zaxis][i]
								vec.reverse! if @base_list[index_base][i] < 0
								if value!=0
									vec.length=value
									e[0].transform!(Geom::Transformation.translation(vec))
								end
							end
						}
					}
				end
			end
			def process_rotate(input)
				value=input.to_f.degrees
				return if !value && value==0
				model =Sketchup.active_model
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				self.rotate_tool(@elements,value)
				self.set_bounds(@elements)
				model.commit_operation
			end
			def rotate_tool(elements,value,index_base=@index_base,index_axis=@index_axis)
				elements.each{|e|
					trans=S4U::S4u_transformer.create_transform(e,index_base)
					t=trans[0]
					(0..2).each{|i|
						if @axis_list[index_axis][i]==1
							vec=[t.xaxis,t.yaxis,t.zaxis][i]
							e[0].transform! Geom::Transformation.rotation(trans[1],vec,value)
						end
					}
				}
			end
			def process_color(input=nil)
				model =Sketchup.active_model
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				delete=[]
				if input
					@elements.each{|e| self.set_material(e,input.to_f,nil) if @paint[0]!=0 || @opacity[0]!=0 }
				else
					@elements.each{|e|
						delete<< e[0].material if e[0].material
						e[0].material=nil
					}
					del=@materials & delete
					@materials=@materials-delete
					del.each{|d| (model.materials.remove d) if d.valid? } if !del.empty?
				end
				model.commit_operation
			end
			def transformer_dynamic(dynamic_mode=@dynamic_mode,ip1=@point1,ip2=@point2)
				@dynamic_mode=dynamic_mode
				return if @dynamic_mode==0 && @transformer!=30
				return if (@dynamic_mode==1 || @dynamic_mode==2) && (!@point1 || !@point2 || @point1==@point2 )
				if @dynamic_mode==3 && @points && @points.length==0
					UI.messagebox Strings["No selected Points(construction point,lines or arc)"]
					return
				end
				@input[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]=nil
				model =Sketchup.active_model
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				min_max=@min_max[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]
				min=min_max[0];max=min_max[1]
				selects=[];dismax=0;dismin=0
				if @dynamic_mode==1
					d=ip1.distance ip2
					@elements.each{|e|
						dis=ip1.distance e[0].transformation.origin
						if dis <= d
							dismax=dis if dismax <= dis
							dismin=dis if dismin >= dis
							selects<< [e,dis]
						else
							selects<< [e,(dis-2*(dis-d))] #if @transformer!=30
						end
					}
				elsif @dynamic_mode==2
					d=ip1.distance ip2
					if @vz.valid? && @vz.length!=0
						 line=[ip1,@vz]
						 @elements.each{|e|
							dis=e[0].transformation.origin.distance_to_line line
							if dis<=d
								dismax=dis if dismax <= dis
								dismin=dis if dismin >= dis
								selects<< [e,dis]
							else
								selects<< [e,(dis-2*(dis-d))] #if @transformer!=30
							end
						 }
					end
				elsif @dynamic_mode==3
					@elements.each{|e|
						p=e[1][1]
						dis=0
						@points.each{|pi|
							d=p.distance pi
							dis= dis+d
						}
						dismax=dis if dismax <= dis
						dismin=dis if dismin >= dis
						selects<< [e,dis]
					}
				elsif @dynamic_mode==4
					if @transformer<10
						@elements.each{|e|
							length=(max-min)>0 ? (rand(max-min+1)+min) : (rand(min-max+1)+max)
							self.scale_tool([e],length) if length!=0
							self.set_material(e,length,min,max) if @paint[0]!=0 || @opacity[0]!=0
						}
					elsif @transformer==10
						@elements.each{|e|
							length=(max-min)>0 ? (rand(max-min+1)+min) : (rand(min-max+1)+max)
							self.move_tool([e],length) if length!=0
							self.set_material(e,length,min,max)  if @paint[0]!=0 || @opacity[0]!=0
						}
					elsif @transformer==20
						@elements.each{|e|
							length=(max-min)>0 ? (rand(max-min+1)+min) : (rand(min-max+1)+max)
							self.rotate_tool([e],length.degrees) if length!=0
							self.set_material(e,length.degrees,min.degrees,max.degrees)  if @paint[0]!=0 || @opacity[0]!=0
						}
					elsif @transformer==30
						@elements.each{|e|  self.set_material(e,nil)  } if @paint[0]!=0 || @opacity[0]!=0
					end
				end
				if dismax!=0
					selects.each{|ob|
						dis=ob[1]
						length=0
						if @transformer<10
							if @dynamic_type<10
								# length=((max-min)*(dis/ dismax)) + min
							# else
								length=(max-min)*((dis/ dismax)**(@dynamic_type+1)) + min
							end
							self.scale_tool([ob[0]],length)
							self.set_material(ob[0],length,min,max) if @paint[0]!=0 || @opacity[0]!=0
						elsif @transformer==10
							if @dynamic_type<10
								# length=((max-min)*(dis/ dismax)) + min
							# else
								length=(max-min)*((dis/ dismax)**(@dynamic_type+1)) + min
							end
							self.move_tool([ob[0]],length)
							self.set_material(ob[0],length,min,max)  if @paint[0]!=0 || @opacity[0]!=0
						elsif @transformer==20
							if @dynamic_type<10
								# ang=((max.degrees-min.degrees)*(dis/ dismax)) + min.degrees
							# else
								ang=(max.degrees-min.degrees)*((dis/ dismax)**(@dynamic_type+1)) + min.degrees
							end
							self.rotate_tool([ob[0]],ang)
							self.set_material(ob[0],ang,min.degrees,max.degrees)  if @paint[0]!=0 || @opacity[0]!=0
						elsif @transformer==30
							if @dynamic_type<10
								# length=((max-min)*(dis/ dismax)) + min
							 # else
								length=(max-min)*((dis/ dismax)**(@dynamic_type+1)) + min
							end
							self.set_material(ob[0],length,min,max) if @paint[0]!=0 || @opacity[0]!=0
						end
					}
				end
				self.set_bounds(@elements)
				model.commit_operation
			end
			def set_material(e,length,min=0,max=100,paint=@paint,opacity=@opacity)
				materials=Sketchup.active_model.materials
				element=e[0]
				if length
					if min #dynamic
						r=1
						range=(max-min).abs
						(r=(length/ range))  if range!=0
						if paint[0] ==1
							if !element.material
								element.material=materials.add
								element.material.color="white"
								@materials<<element.material
							end
							m= element.material.color
							mat=S4U::S4u_transformer.rgb_to_hsl(m.red,m.green,m.blue)
							hsl=[]
							(1..3).each{|i|
								max=paint[i][1];min=paint[i][0]
								range=max-min
								hsl << (r*range +mat[i-1]+min)
							}
							hsl[1]= hsl[1]>100 ?  100 :  ((hsl[1]<0) ? 0 : hsl[1])
							hsl[2]= hsl[2]>100 ?  100 :  ((hsl[2]<0) ? 0 : hsl[2])
							color=S4U::S4u_transformer.hsl_to_rgb(hsl[0].divmod(360)[1],0.01*hsl[1],0.01*hsl[2])
							element.material.color=color
						end
						if opacity[0] ==1
							max=opacity[1][1];min=opacity[1][0]
							range=max-min
							if !element.material
								element.material=materials.add
								element.material.color="white"
								h=r*range +min+element.material.alpha
								element.material.alpha=0.01*h.divmod(360)[1]
								@materials<<element.material
							else
								h=r*range +min+element.material.alpha
								h=0.01*h.divmod(360)[1]
								(element.material.alpha=h) if element.material.alpha!=h
							end
						end
					else  #input value
						if paint[0] ==1
							if !element.material
								element.material=materials.add
								element.material.color="white"
								@materials<<element.material
							end
							m= element.material.color
							mat=S4U::S4u_transformer.rgb_to_hsl(m.red,m.green,m.blue)
							hsl=[]
							(1..3).each{|i|
							max=paint[i][1];min=paint[i][0]
							h=length+mat[i-1]
							hsl<< ((h>max) ? (max) : ((h<min) ? (min): h) )
							}
							color=S4U::S4u_transformer.hsl_to_rgb(hsl[0],hsl[1]*0.01,hsl[2]*0.01)
							element.material.color=color
						end
						if opacity[0] ==1
							max=opacity[1][1];min=opacity[1][0]
							if !element.material
								element.material=materials.add
								element.material.color="white"
								@materials<<element.material
							end
							h=length+element.material.alpha*100.0
							h=(h>max) ? max : ((h<min) ? (min): h)
							element.material.alpha=h*0.01
						end
					end
				else # random
					if paint[0] ==1
						hsl=[]
						(1..3).each{|i|
							max=paint[i][1];min=paint[i][0]
							range=max-min
							hsl<< ((range >=0) ? min+rand(range) : max+rand(range))
						}
						color=S4U::S4u_transformer.hsl_to_rgb(hsl[0],hsl[1]*0.01,hsl[2]*0.01)
						if !element.material
							element.material=materials.add
							@materials<<element.material
						end
						element.material.color=color
					end
					if opacity[0] ==1
						if !element.material
							element.material=materials.add
							element.material.color="white"
							@materials<<element.material
						end
						max=opacity[1][1];min=opacity[1][0]
						range=max-min
						t = ((range >=0) ? min+rand(range) : max+rand(range))
						element.material.alpha=t*0.01
					end
				end
			end
			def reset_scales(index_base=@index_base)
				model =Sketchup.active_model
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				@elements.each{|e|
					trans=S4U::S4u_transformer.create_transform(e,index_base)
					t=e[0].transformation
					vx=(t.xaxis.length==0) ? (t.yaxis.cross t.zaxis) : t.xaxis
					vy=(t.yaxis.length==0) ? (t.zaxis.cross t.xaxis) : t.yaxis
					vz=(t.zaxis.length==0) ? (t.xaxis.cross t.yaxis) : t.zaxis
					if vx.length!=0 && vy.length!=0 && vz.length!=0
					# if t.xaxis.length!=0 && t.yaxis.length!=0 && t.zaxis.length!=0
						# e[0].transformation=Geom::Transformation.new(t.xaxis,t.yaxis,t.zaxis,trans[1])
						e[0].transformation=Geom::Transformation.new(vx,vy,vz,trans[1])
						e[1]=S4U::S4u_transformer.get_bounds(e[0])
						new_trans=S4U::S4u_transformer.create_transform(e,index_base)
						if trans[1]!=new_trans[1]
							vec=trans[1]-new_trans[1]
							e[0].transform!(Geom::Transformation.translation(vec))
						end
					end
				}
				self.set_bounds(@elements)
				model.commit_operation
			end
			def reset_transforms(transform=true,index_base=@index_base)
				model =Sketchup.active_model
				model.start_operation @active_tool[@transformer.div(10)],true,false,false
				if transform
					@elements.each{|e|
						trans=S4U::S4u_transformer.create_transform(e,index_base)
						e[0].transformation=Geom::Transformation.new([1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1])
						e[1]=S4U::S4u_transformer.get_bounds(e[0])
						new_trans=S4U::S4u_transformer.create_transform(e,index_base)
						if trans[1]!=new_trans[1]
							vec=trans[1]-new_trans[1]
							e[0].transform!(Geom::Transformation.translation(vec))
						end
					}
				else
					@elements.each{|e| S4U::S4u_transformer.reset_rotate(e[0]) }
				end
				self.set_bounds(@elements)
				model.commit_operation
			end
			def parse_length(input)
				(return 0) if !input
				begin
					value=input.to_s.to_l
				rescue ArgumentError
					value=input.to_s.to_f
				end
				return value
			end
			def onKeyUp(key, repeat, flags, view)
				if ( key == CONSTRAIN_MODIFIER_KEY)
					view.lock_inference if  view.inference_locked?
					@vec_shift=nil
				elsif ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
					@ctrl_press=nil
				end
			end
			def onKeyDown(key, repeat, flags, view)
				if ((key==VK_CONTROL) && IS_WIN ) || ((key==VK_ALT) && IS_OSX)
					@ctrl_press=true
				elsif key==CONSTRAIN_MODIFIER_KEY
					@vec_shift=@vec
					(view.lock_inference @ip1,@ip) if @ip1.valid? && @ip.valid? && @dynamic_mode!=0 && (@dynamic_mode<=2)
				elsif ((key==9) && IS_WIN ) || ((key==48) && IS_OSX)
					self.get_dynamic_parameter
				elsif key== VK_UP
					@index_axis=2
				elsif key== VK_DOWN
					@index_base+=1
					@index_base=@index_base.divmod(@base.length)[1]
				elsif key== VK_RIGHT
					@index_axis=0
				elsif key== VK_LEFT
					@index_axis=1
				end
				self.setstatus view
			end
			def get_dynamic_parameter()
				prompts = [Strings["Transformer?"],Strings["Dynamic mode?"],Strings["Dynamic type?"],
				Strings["Min?"],Strings["Max?"],Strings["Paint color?(HSL)"],
				Strings["Hue? (0->359)"],Strings["Saturation? (0->100%)"],Strings["Lightness? (0->100%)"],
				Strings["Opacity?"],Strings["Transparent? (0->100%)"]]
				title=Strings["Enter Dynamic Parameter"]
				modes=[Strings["No dynamic"],Strings["Circle"],Strings["Linear"],Strings["Points"],Strings["Random"]]
				types=[Strings["y=x"],Strings["y=x**2"],Strings["y=x**3"],Strings["y=x**4"],Strings["y=x**5"]]
				paint=[Strings["No"],Strings["Yes"]]
				active_tool=[Strings["Scale distance"],Strings["Scale ratio"],Strings["Scale fixed length"],
				Strings["Move"],Strings["Rotate"],Strings["Color"]]
				list=[active_tool.join('|'),modes.join('|'),types.join('|'),"","",paint.join('|'),"","","",paint.join('|'),"",""]
				# list=[active_tool.join('|'),modes.join('|'),"","","",paint.join('|'),"","","",paint.join('|'),"",""]
				mode=@dynamic_mode<5 ? modes[@dynamic_mode] : modes[0]
				type=types[@dynamic_type]
				# type=@dynamic_type.to_f
				unit=[Strings["(length)"],Strings["(ratio)"],Strings["(degrees)"]]
				min_max=@min_max[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]
				index_tool= @transformer<10 ? @transformer : (@transformer.div(10)+2)
				if @transformer<10
					if @transformer==0 || @transformer==2
						(3..4).each{|i| prompts[i]+=unit[0]}
						defaults = [active_tool[index_tool],mode,type,min_max[0],min_max[1],paint[@paint[0]],@paint[1].join('-'),@paint[2].join('-'),@paint[3].join('-'),paint[@opacity[0]],@opacity[1].join('-')]
					elsif @transformer==1
						(3..4).each{|i| prompts[i]+=unit[1]}
						defaults = [active_tool[index_tool],mode,type,min_max[0],min_max[1],paint[@paint[0]],@paint[1].join('-'),@paint[2].join('-'),@paint[3].join('-'),paint[@opacity[0]],@opacity[1].join('-')]
					end
				elsif @transformer==10
					(3..4).each{|i| prompts[i]+=unit[0]}
					defaults = [active_tool[index_tool],mode,type,min_max[0],min_max[1],paint[@paint[0]],@paint[1].join('-'),@paint[2].join('-'),@paint[3].join('-'),paint[@opacity[0]],@opacity[1].join('-')]
				elsif @transformer==20
					(3..4).each{|i| prompts[i]+=unit[2]}
					defaults = [active_tool[index_tool],mode,type,min_max[0],min_max[1],paint[@paint[0]],@paint[1].join('-'),@paint[2].join('-'),@paint[3].join('-'),paint[@opacity[0]],@opacity[1].join('-')]
				elsif @transformer==30
					defaults = [active_tool[index_tool],mode,type,min_max[0],min_max[1],paint[@paint[0]],@paint[1].join('-'),@paint[2].join('-'),@paint[3].join('-'),paint[@opacity[0]],@opacity[1].join('-')]
				end
				input = UI.inputbox(prompts,defaults,list,title)
				if input
					index_tool=active_tool.index(input[0])
					@dynamic_mode=modes.index(input[1])
					@dynamic_type=types.index(input[2])
					# @dynamic_type=input[2].to_f
					min=input[3]
					max=input[4]
					if index_tool<3
						@transformer=index_tool
						if index_tool==1
							min=min.to_s.to_f
							max=max.to_s.to_f
						else
							min=parse_length min
							max=parse_length max
						end
					else
						@transformer= 10*(index_tool-2)
						if index_tool==3
							min=parse_length min
							max=parse_length max
						elsif index_tool==4
							min=min.to_f
							max=max.to_f
						elsif index_tool==5
							min=min.to_f
							max=max.to_f
						end
					end
					@min_max[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]=[min,max]
					@paint[0]=paint.index(input[5])
					(0..2).each{|ip|
						if input[ip+6].include?('-')
							value=input[ip+6].split('-')
							(0..1).each{|i|
								v=value[i].to_f
								if ip==0
									v= (0<= v &&  v<360) ? v : ((0<v) ? 359 : 0)
								else
									v= (0<= v &&  v<=100) ? v : ((0<v) ? 100 : 0)
								end
								@paint[ip+1][i]=v
							}
						else
							(0..1).each{|i|
								v=input[ip+6].to_f
								if ip==0
									v= (0<= v &&  v<360) ? v : ((0<v) ? 359 : 0)
								else
									v= (0<= v &&  v<=100) ? v : ((0<v) ? 100 : 0)
								end
								@paint[ip+1][i]=v
							}
						end
					}
					@opacity[0]=paint.index(input[9])
					if input[10].include?('-')
						value=input[10].split('-')
						(0..1).each{|i|
							v=value[i].to_f
							v= (0<= v &&  v<=100) ? v : ((0< v) ? 100 : 0)
							@opacity[1][i]=v
						}
					else
						(0..1).each{|i|
							v=input[10].to_f
							v= (0<= v &&  v<=100) ? v : ((0< v) ? 100 : 0)
							@opacity[1][i]=v
						}
					end
				end
			end
			def enableVCB?
				return true
			end
			def onReturn(view)
				input=@input[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]
				if input
					if @transformer<10
						self.process_scale(input)
					elsif @transformer==10
						self.process_move(input)
					elsif @transformer==20
						self.process_rotate(input)
					elsif @transformer==30
						self.process_color(input)
					end
				else
					if @dynamic_mode!=0
						self.transformer_dynamic(@dynamic_mode,@point1,@point2)
					end
				end
			end
			def onCancel(reason, view)
				 self.reset
			end
			def onUserText(text, view)
				decimal="," ;decimal="." if Sketchup.parse_length "1,2"
				if @state==1
						vec=@ip.position - @ip1.position
						vec.length=self.parse_length(text)
						@point2=@ip1.position + vec
						@point1=@ip1.position
						self.reset
						self.transformer_dynamic(@dynamic_mode,@point1,@point2)
						return
				end
				if (text.include?(decimal)) && @dynamic_mode!=0
					input=text.split(decimal)
					@input[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]=nil
					min=input[0]
					max=input[1]
					if @transformer<10
						if @transformer==1
							min=min.to_s.to_f
							max=max.to_s.to_f
						else
							min=parse_length min
							max=parse_length max
						end
					elsif @transformer==10
						min=parse_length min
						max=parse_length max
					elsif @transformer==20
						min=min.to_s.to_f
						max=max.to_s.to_f
					elsif @transformer==30
						min=min.to_s.to_f
						max=max.to_s.to_f
					end
					@min_max[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]=[min,max]
					self.transformer_dynamic(@dynamic_mode,@point1,@point2)
				else
					input=text
					if @transformer<10
						if @transformer==1
							input=input.to_s.to_f
						else
							input=parse_length input
						end
					elsif @transformer==10
						input=parse_length input
					elsif @transformer==20
						input=input.to_s.to_f
					elsif @transformer==30
						input=input.to_s.to_f
					end
					@input[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]=input
					if @transformer<10
						self.process_scale(input)
					elsif @transformer==10
						self.process_move(input)
					elsif @transformer==20
						self.process_rotate(input)
					elsif @transformer==30
						self.process_color(input)
					end
				end
				self.setstatus(view)
			end
			def setstatus(view=nil)
				sm=@scale_list
				dm=@dynamic_list
				unit=[Strings["(length)"],Strings["(ratio)"],Strings["(degrees)"],Strings["(Hue)"]]
				prompts=Strings["Enter "]
				dmstr=Strings[" | Dymanic mode: "] + dm[@dynamic_mode].upcase
				min_max=@min_max[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]
				dmstr=dmstr+Strings[" | Min-Max: "] + min_max[0].to_s + " - " + min_max[1].to_s if @dynamic_mode!=0
				smstr=""
				smstr=Strings[" | Scale mode: "] + sm[@scale_mode].upcase if @transformer<10
				inputstr=""
				input=@input[@transformer.divmod(10)[0]][@transformer.divmod(10)[1]]
				if input
					inputstr=Strings[" | Input: "] + input.to_s
				end
				s=Strings["Transformer: "] + @active_tool[@transformer.divmod(10)[0]].upcase + smstr + Strings[" | Base: "] + @base[@index_base].upcase + Strings[" | Axis: "]  + @axis[@index_axis].upcase + dmstr + inputstr
				if @transformer<10
					if @transformer==0 || @transformer==2
						prompts+=unit[0]
					elsif @transformer==1
						prompts+=unit[1]
					end
				elsif @transformer==10
					prompts+=unit[0]
				elsif @transformer==20
					prompts+=unit[2]
				elsif @transformer==30
					prompts+=unit[3]
				end
				Sketchup::set_status_text s
				Sketchup::vcb_label=prompts
				@menu_base.set_select(@index_base) if @menu_base
				@menu_axis.set_select(@index_axis) if @menu_axis
				@menu_dynamic.set_select(@dynamic_mode) if @menu_dynamic
				@menu_scale.set_select(@scale_mode) if @menu_scale
				@menu_main.set_select(@transformer.divmod(10)[0]) if @menu_main
				@menu_reset.set_select(@index_reset) if @menu_reset
				@menu_extend.set_select(@index_extend) if @menu_extend
				view.invalidate if view!=nil
			end
			def resume(view)
				@size_pixels = (view.pixels_to_model 9,ORIGIN)
				self.setstatus(view)
			end
		end # class
		def self.hsl_to_rgb(h,s,l)
			h=0 if h>=360 || h<0
			s=1 if  s<0 || s>1
			l=1 if  l<0 || l>1
			c = l*s
			x = c*(1-((h/ 60.0).divmod(2)[1]-1).abs)
			m = l-c
			change=[[c,x,0],[x,c,0],[0,c,x],[0,x,c],[x,0,c],[c,0,x]]
			index=(h/ 60.0).to_i
			color=change[index]
			return [ (256*(color.x+m)).round, (256*(color.y+m)).round,(256*(color.z+m)).round]
		end
		def self.rgb_to_hsl(r, g, b)
			r= r/ 255.0; g= g/ 255.0;b= b/ 255.0
			max = [r, g, b].max {|a,b| a <=> b}
			min = [r, g, b].min {|a,b| a <=> b}
			h =(max + min) / 2;  s = (max + min) / 2; l = (max + min) / 2;
			if(max == min)
				h= 0; s=0
			else
				d = max - min;
				s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
				case max
				when r
					h = (g - b) / d + (g < b ? 6 : 0)
				when g
					h = (b - r) / d + 2
				when b
					h = (r - g) / d + 4
				end
				h =h/ 6.0
			end
			return [h*360, s, l]
		end
		def self.reset_rotate(element)
			t=element.transformation
			tedit=Sketchup.version.to_i>=16 ? Sketchup.active_model.axes.transformation : Sketchup.active_model.edit_transform
			a=t.zaxis.angle_between tedit.zaxis
			if a!=0
				vec = (a==Math::PI) ? tedit.xaxis : (t.zaxis.cross tedit.zaxis)
				if vec.length>0
					rz=Geom::Transformation.rotation t.origin, vec ,a
					element.transformation =rz*element.transformation
				end
			end
			t=element.transformation
			a=t.xaxis.angle_between tedit.xaxis
			if a!=0
				vec=(a == Math::PI) ? tedit.zaxis : (t.xaxis.cross tedit.xaxis)
				if vec.length>0
					rx=Geom::Transformation.rotation t.origin,vec,a
					element.transformation=rx*element.transformation
				end
			end
		end
		def self.reset_transformer(mode)
			model = Sketchup.active_model
			objects=model.selection.select{|e| (e.is_a?Sketchup::Group) || (e.is_a?Sketchup::ComponentInstance) }
			if objects.empty?
				UI.messagebox Strings["Select groups or components"]
			else
				model.start_operation Strings["Reset Transformer"]
				if mode==0
					objects.each{|obj|
						t=obj.transformation
						vx=(t.xaxis.length==0) ? (t.yaxis.cross t.zaxis) : t.xaxis
						vy=(t.yaxis.length==0) ? (t.zaxis.cross t.xaxis) : t.yaxis
						vz=(t.zaxis.length==0) ? (t.xaxis.cross t.yaxis) : t.zaxis
						vx= X_AXIS if vx.length==0
						vy= Y_AXIS if vy.length==0
						vz= Z_AXIS if vz.length==0
						obj.transformation=Geom::Transformation.new(vx,vy,vz,t.origin)
					}
				elsif mode==1
					 objects.each{|obj| self.reset_rotate(obj) }
				elsif mode==2
					 objects.each{|obj| obj.transformation = Geom::Transformation.new(obj.transformation.origin) }
				end
				model.selection.add objects
				model.commit_operation
			end
		end
		def self.transformer_main(mode)
			model = Sketchup.active_model
			objects=[] ;points=[]
			model.selection.each{|e|
				if (e.is_a?Sketchup::Group) || (e.is_a?Sketchup::ComponentInstance)
					objects<< e
				elsif e.is_a?Sketchup::ConstructionPoint
					points << e.position
				elsif e.is_a?Sketchup::Edge
					points << e.start.position
					points << e.end.position
				end
			}
			points.uniq!
			if objects.empty?
				UI.messagebox Strings["Select groups or components"]
			else
				model.select_tool S4U::S4u_transformer::Transformer.new(objects,mode*10,points)
			end
		end
		def self.move_object_to_point()
			model=Sketchup.active_model
			tedit=Sketchup.active_model.axes.transformation
			objects=[] ;cpoints=[]
			model.selection.each{|e|
				if e.is_a?Sketchup::ConstructionPoint
					cpoints << e
				else
					objects<< e
				end
			}
			comp=[]
			cpoints.each{|p|
				ray=[p.position,tedit.zaxis.reverse]
				com = model.raytest(ray,false)
				 if com
					comp<< [p.position,com]
				 else
					ray=[p.position,tedit.zaxis]
					com = model.raytest(ray,false)
					comp<< [p.position,com] if com
				end
			}
			model.start_operation TOOL,true,false,false
			if cpoints.empty?
				model.select_tool S4U::S4u_transformer::Transformer.new(objects,10,true)
			else
				comp.each{|e|
					vec=e[0]- e[1][0]
					trans=Geom::Transformation.translation vec
					c=(model.active_entities.to_a & objects) & e[1][1]
					if c.length>0 && defined?(c[0].transformation)
						c[0].transform! trans
					end
				}
			end
			model.commit_operation
			rescue=>error
			p error
			p error.backtrace.join("\n")
			model.abort_operation
		end
		def self.extend_main
			model =Sketchup.active_model
			objects=model.selection.select{|e| (e.is_a?Sketchup::Group) || (e.is_a?Sketchup::ComponentInstance)}
			if objects.empty?
				UI.messagebox Strings["Select groups or components"]
			else
				model.start_operation Strings["Extend Zaxis Scale"] ,true,false,false
				objects.each{|obj|
					tg=obj.transformation
					vec=tg.zaxis
					bounds=self.get_bounds(obj)
					d=bounds[0][2]
					p=bounds[1]
					if d>0
						vec.length=d
						p.transform!(Geom::Transformation.translation(vec))
						ray=[p,vec]
						point=model.raytest ray
						if point
							sz=1+((p.distance point[0])/ d.to_f)
							obj.transformation = obj.transformation*Geom::Transformation.new([1,0,0,0,0,1,0,0,0,0,sz,0,0,0,0,1])
						end
					end
				}
				model.selection.add objects
				model.commit_operation
			end
		end
		def self.get_bounds(element)
			a=element.transformation.to_a
			b=nil
			if element.is_a?Sketchup::ComponentInstance
				b=element.definition.bounds
			elsif element.is_a?Sketchup::Group
				b=element.local_bounds
			end
			if b
				corner= (0..7).collect{|i| b.corner(i).clone.transform! element.transformation }
				w=corner[0].distance corner[1]
				h=corner[0].distance corner[2]
				d=corner[0].distance corner[4]
				return [[w,h,d],corner[0],corner[7]]
			end
			return nil
		end
		def self.create_transform(e,origin=0)
			#base=["min","max-x","max-y","max-xy","max_z","max-xz","max-yz","max","bottom","center","top","front","right","left","back","origin"]
			base=[[0,0,0],[-1,0,0],[0,-1,0],[-1,-1,0],[0,0,-1],[-1,0,-1],[0,-1,-1],[-1,-1,-1],[0.5,0.5,0],[0.5,0.5,0.5],[0.5,0.5,-1],[0.5,0,0.5],[-1,0.5,0.5],[0,0.5,0.5],[0.5,-1,0.5],[0,0,0]]
			object=e[0]
			p=e[1][1].clone
			b=e[1][0]
			t=object.transformation
			vx=t.xaxis;vy=t.yaxis ;vz=t.zaxis
			origin_new=[(b.x*base[origin][0]),(b.y*base[origin][1]),(b.z*base[origin][2])]
			vec=[vx,vy,vz]
			(0..2).each{|i|
				if origin_new[i]!=0
					vec[i].length=origin_new[i].abs
					p=p+vec[i]
				end
				vec[i].reverse! if origin_new[i]<0
			}
			p=t.origin	if origin==15
			trans=nil
			vx=(t.xaxis.length==0) ? (t.yaxis.cross t.zaxis) : t.xaxis
			vy=(t.yaxis.length==0) ? (t.zaxis.cross t.xaxis) : t.yaxis
			vz=(t.zaxis.length==0) ? (t.xaxis.cross t.yaxis) : t.zaxis
			if vx.length!=0 && vy.length!=0 && vz.length!=0
				trans=Geom::Transformation.new(vx,vy,vz,p.clone)
			else
				trans=Geom::Transformation.new(p.clone)
			end
			return [trans,p.clone]
		end
		def self.main(mode)
			case mode
			when 0,1,2,3
				transformer_main(mode)
			when 4
				self.move_object_to_point
			when 5
				self.extend_main
			when 6,7,8
				reset_transformer(mode-6)
			end
		end
	end
end
class S4U::S4u_item
		attr_accessor :position,:width,:height,:select,:mouse_over,:text
		def initialize(position=[0,0,0],text="",w=60,h=20,select=false)
			@position=position
			@width=w
			@height=h
			@text=text
			@select=select
			@mouse_over=false
			@color=["DarkTurquoise","PowderBlue","DarkTurquoise"]
			@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
			@scale_factor=1.8 if @scale_factor>1.8
		end
		def draw(view)
			p=[]
			p<< Geom::Point3d.new( @position.x,@position.y,0)
			p<< Geom::Point3d.new( (@position.x+@width),@position.y,0)
			p<< Geom::Point3d.new( (@position.x+@width),(@position.y+@height),0)
			p<< Geom::Point3d.new( @position.x,(@position.y+@height),0)
			view.drawing_color = (@mouse_over ?  @color[2] : (@select ? @color[0] : @color[1]))
			view = view.draw2d GL_QUADS, p
			view.drawing_color = "black"
			view.line_width = 1
			view = view.draw2d GL_LINE_LOOP, p
			view.drawing_color = "MidnightBlue"
			po = Geom::Point3d.new((@position.x+(@width/ (2+@text.length))),@position.y,0)
			options={
			  :font => "Arial",
			  :size => 9.5*@scale_factor
			}
			view.draw_text po, @text,options
		end
end
class S4U::S4u_items
		attr_accessor :items,:width,:height ,:name,:texts,:position ,:unique ,:enable ,:head
		def initialize(name="",texts=[],unique=true,position=[0,0,0],w=120,head=50,h=24)
			@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
			@scale_factor=1.8 if @scale_factor>1.8
			w=w*@scale_factor
			head=head*@scale_factor
			h=h*@scale_factor
			@items=[]
			@name=name.capitalize
			@unique=unique
			@width=w
			@height=h
			@texts=texts
			@enable=1
			@position=position
			@head=head
			w1=@width-@head
			@texts.each_index{|i|
				w=w1/ @texts.length.to_f
				p=[@position.x+@head+w*i,@position.y,0]
				@items<<  ( S4U::S4u_item.new(p,@texts[i],w,@height,i==0))
			}
		end
		def set_position_items
			w=0
			(0..@items.length-1).each{|i|
				p=[@position.x+@head+w,@position.y,0]
				@items[i].position=p
				w += @items[i].width
			}
		end
		def draw(view)
			if @enable!=0
				p=[]
				p<< Geom::Point3d.new( @position.x,@position.y,0)
				p<< Geom::Point3d.new( (@position.x+@head),@position.y,0)
				p<< Geom::Point3d.new( (@position.x+@head),@position.y+@height,0)
				p<< Geom::Point3d.new( @position.x,@position.y+@height,0)
				view.drawing_color = "CornflowerBlue"
				view = view.draw2d GL_QUADS, p
				view.drawing_color = "black"
				view.line_width = 1
				view = view.draw2d GL_LINE_LOOP, p
				po = Geom::Point3d.new(@position.x+5,@position.y,0)
				view.drawing_color = "MidnightBlue"
				options={
				  :font => "Arial",
				  :size => 10*@scale_factor
				}
				view.draw_text po, @name,options
				@items.each{|i| i.draw(view)} if @enable==1
			end
		end
		def set_select(index)
			@items.each{|i| i.select=false}
			@items[index].select=true
		end
end
class S4U::S4u_menu
		attr_accessor :menu,:position,:last
		def initialize
			@menu=[]
			@position=[0,0,0]
			@last=[0,0,0]
			@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1

		end
		def add(items)
			@menu<< items
			@last.x +=items.width
			return items
		end
		def remove(items)
			@last.x-= items.width
			@menu.delete(items)
		end
		def self.get_menu(name)
			@menu.each{|m|
				if m.name==name
					sel=[]
					m.items.each{|i| sel<<i if i.select}
					return [m ,sel]
				end
			}
		end
		def process_onLButtonDown( x, y)
			result=nil
			@menu.each{|m|
				m.items.each{|item|
					if (x.between?(item.position.x,item.position.x+item.width)) && (y.between?(item.position.y,item.position.y+item.height) )
						list_select=[]
						m.items.each{|i|
							if i==item
								if m.unique
									item.select= true
								else
									item.select= !(item.select && ((m.items.any?{|i1| i1.select && (i1!=item)})))
								end
							else
								i.select=false if m.unique
							end
							list_select<< i if i.select
						}
						result= [m,list_select]
					end
				} if m.enable==1
				if (x.between?(m.position.x,m.position.x + m.head)) && (y.between?(m.position.y,m.position.y + m.height))
					m.enable= (m.enable==1)? 2 : 1
					(0..@menu.length-2).each{|i|
						if @menu[i].position.y==@menu[i+1].position.y
							if @menu[i].enable==1
								@menu[i+1].position.x= @menu[i].position.x+@menu[i].width
							elsif @menu[i].enable==2
								@menu[i+1].position.x= @menu[i].position.x+@menu[i].head
							end
						end
						@menu[i+1].set_position_items
					}
					list_select = m.items.select{|i| i.select}
					result=[m,list_select]
				end
			}
			return result
		end
		def reset
			(0..@menu.length-2).each{|i|
				if @menu[i].position.y==@menu[i+1].position.y
					if @menu[i].enable==1
						@menu[i+1].position.x= @menu[i].position.x+@menu[i].width
					elsif @menu[i].enable==2
						@menu[i+1].position.x= @menu[i].position.x+@menu[i].head
					end
				end
				@menu[i+1].set_position_items
			}
		end
		def process_onMouseMove(x, y)
			@menu.each{|m|
				m.items.each{|item|
					if (x.between?(item.position.x,item.position.x+item.width)) && (y.between?(item.position.y,item.position.y+item.height))
						item.mouse_over= true
					else
						item.mouse_over= false
					end
				}
			}
		end
		def draw(view)
			@menu.each{|m| m.draw(view)}
		end
end